blob: 7a7b831afb7ff34539aa3ad264a71220a49daa6e [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblasa9cab1f2025-01-13 12:04:42 +010016RELEASE=ReleaseSEVENTEEN
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblasb1dbb6d2025-03-18 12:37:01 +010018DOCKER_TAG="17"
garciadeblas2bf767a2021-05-19 10:54:46 +020019DEVOPS_PATH=/usr/share/osm-devops
garciadeblas93c61312016-09-28 15:12:48 +020020
garciadeblas38d91ee2019-11-07 16:31:23 +010021function usage(){
22 echo -e "usage: $0 [OPTIONS]"
garciadeblas81077ae2023-07-03 19:31:15 +020023 echo -e "Install OSM"
garciadeblas38d91ee2019-11-07 16:31:23 +010024 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000025 echo -e " -h / --help: print this help"
26 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblas38d91ee2019-11-07 16:31:23 +010027 echo -e " -r <repo>: use specified repository name for osm packages"
28 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
29 echo -e " -u <repo base>: use specified repository url for osm packages"
30 echo -e " -k <repo key>: use specified repository public key url"
garciadeblas96155042022-06-22 16:26:22 +020031 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
garciadeblas8d8cd992024-05-21 16:04:14 +020032 echo -e " -c <kubernetes engine>: use a specific kubernetes engine (options: kubeadm, k3s), default is kubeadm"
33 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
34 echo -e " -M <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as mgmt cluster instead of OSM cluster"
35 echo -e " -G <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as auxiliary cluster instead of OSM cluster"
36 echo -e " --no-mgmt-cluster: Do not provision a mgmt cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
37 echo -e " --no-aux-cluster: Do not provision an auxiliary cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
38 echo -e " -D <devops path>: use local devops installation path"
garciadeblas81077ae2023-07-03 19:31:15 +020039 echo -e " -s <namespace> namespace when installed using k8s, default is osm"
garciadeblas38d91ee2019-11-07 16:31:23 +010040 echo -e " -H <VCA host> use specific juju host controller IP"
41 echo -e " -S <VCA secret> use VCA/juju secret key"
42 echo -e " -P <VCA pubkey> use VCA/juju public key file"
garciadeblas38d91ee2019-11-07 16:31:23 +010043 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
magnussonl1bbe9452020-02-25 13:43:17 +010044 echo -e " --pla: install the PLA module for placement support"
garciadeblas81077ae2023-07-03 19:31:15 +020045 echo -e " --old-sa: install old Service Assurance framework (MON, POL); do not install Airflow and Pushgateway"
garciadeblasef3f37c2024-05-31 17:30:48 +020046 echo -e " --ng-sa: install new Service Assurance framework (Airflow, AlertManager and Pushgateway) (enabled by default)"
47 echo -e " -o <COMPONENT>: ONLY installs the specified component (k8s_monitor, ng-sa, k8scluster, docker, deploy-osm)"
garciadeblas8d8cd992024-05-21 16:04:14 +020048 echo -e " -O <openrc file path/cloud name>: install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
49 echo -e " -N <openstack public network name/ID>: public network name required to setup OSM to OpenStack"
50 echo -e " -f <path to SSH public key>: public SSH key to use to deploy OSM to OpenStack"
51 echo -e " -F <path to cloud-init file>: cloud-init userdata file to deploy OSM to OpenStack"
52 echo -e " -w <work dir>: Location to store runtime installation"
David Garcia79f4f532020-04-07 12:59:34 +020053 echo -e " -l: LXD cloud yaml file"
54 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020055 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000056 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
57 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
garciadeblas9a510862021-04-21 14:15:56 +020058 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas96155042022-06-22 16:26:22 +020059 echo -e " --debug: debug mode"
garciadeblas9a510862021-04-21 14:15:56 +020060 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
garciadeblas96155042022-06-22 16:26:22 +020061 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
David Garcia79f4f532020-04-07 12:59:34 +020062 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblas38d91ee2019-11-07 16:31:23 +010063 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
64 echo -e " --nojuju: do not juju, assumes already installed"
garciadeblas38d91ee2019-11-07 16:31:23 +010065 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
66 echo -e " --nohostclient: do not install the osmclient"
67 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
garciadeblascb129372020-11-14 23:06:42 +000068 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
69 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblas38d91ee2019-11-07 16:31:23 +010070 echo -e " --showopts: print chosen options and exit (only for debugging)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020071 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
72 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
73 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
garciadeblascb129372020-11-14 23:06:42 +000074 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
aticig5d19ac22022-05-06 13:46:22 +030075 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
garciadeblas96155042022-06-22 16:26:22 +020076 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020077 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
78 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
David Garcia4bd2bf02021-05-05 19:01:43 +020079 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020080 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
garciadeblascb129372020-11-14 23:06:42 +000081 echo -e " [--tag]: Docker image tag. (--charmed option)"
82 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
garciadeblas38d91ee2019-11-07 16:31:23 +010083}
84
garciadeblasd8bc5c32018-05-09 17:37:56 +020085add_repo() {
86 REPO_CHECK="^$1"
87 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
88 if [ $? -ne 0 ]
89 then
garciadeblasbd925e42018-06-14 14:32:12 +020090 need_packages_lw="software-properties-common apt-transport-https"
garciadeblas0bc87522021-10-20 22:16:17 +020091 echo -e "Checking required packages to add ETSI OSM debian repo: $need_packages_lw"
garciadeblasbd925e42018-06-14 14:32:12 +020092 dpkg -l $need_packages_lw &>/dev/null \
93 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
garciadeblas5f420b12022-02-10 01:43:59 +010094 || sudo apt-get -qy update \
Mike Marchetti34124182018-10-16 08:22:30 -040095 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020096 || exit 1
97 dpkg -l $need_packages_lw &>/dev/null \
98 || ! echo -e "Installing $need_packages_lw requires root privileges." \
99 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -0400100 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +0200101 || exit 1
garciadeblasbc97a012022-04-21 00:29:02 +0200102 wget -q -O OSM-ETSI-Release-key.gpg "$REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg"
103 sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add OSM-ETSI-Release-key.gpg \
104 || ! echo -e "Could not add GPG key $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" \
105 || exit 1
garciadeblas5f420b12022-02-10 01:43:59 +0100106 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1"
garciadeblasbc97a012022-04-21 00:29:02 +0200107 sudo DEBIAN_FRONTEND=noninteractive apt-get -y update
garciadeblas429b9f82018-03-20 02:09:44 +0100108 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +0200109 fi
110
111 return 1
garciadeblas55490d42016-10-29 14:22:03 +0200112}
113
garciadeblas25e87d22020-01-31 14:27:29 +0100114clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +0530115dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +0530116if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +0530117 # Clean the previous repos that might exist
118 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
119fi
120}
121
garciadeblas0bc87522021-10-20 22:16:17 +0200122function configure_apt_proxy() {
123 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
124 OSM_APT_PROXY=$1
125 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
126 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
127 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
128 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
129Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
130EOF"
131 else
132 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
133 fi
garciadeblas5f420b12022-02-10 01:43:59 +0100134 sudo apt-get -y update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas0bc87522021-10-20 22:16:17 +0200135 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
136}
137
garciadeblase3a84a52024-09-27 11:34:55 +0200138while getopts ":a:c:e:r:n:k:u:R:D:o:O:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:G:M:-: hy" o; do
garciadeblas8d8cd992024-05-21 16:04:14 +0200139
garciadeblas38d91ee2019-11-07 16:31:23 +0100140 case "${o}" in
Antonio Marsico75a38c72020-12-21 17:29:42 +0100141 D)
142 DEVOPS_PATH="${OPTARG}"
143 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100144 r)
145 REPOSITORY="${OPTARG}"
146 ;;
147 R)
148 RELEASE="${OPTARG}"
149 ;;
150 u)
151 REPOSITORY_BASE="${OPTARG}"
152 ;;
153 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100154 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100155 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100156 -)
157 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100158 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100159 :)
160 echo "Option -$OPTARG requires an argument" >&2
161 usage && exit 1
162 ;;
163 \?)
164 echo -e "Invalid option: '-$OPTARG'\n" >&2
165 usage && exit 1
166 ;;
167 h)
168 usage && exit 0
169 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100170 *)
171 ;;
172 esac
173done
174
garciadeblas25e87d22020-01-31 14:27:29 +0100175clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200176add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas5f420b12022-02-10 01:43:59 +0100177sudo DEBIAN_FRONTEND=noninteractive apt-get -qy update
178sudo DEBIAN_FRONTEND=noninteractive apt-get -y install osm-devops
Antonio Marsico75a38c72020-12-21 17:29:42 +0100179$DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"